/****************************************************************************
*  This file is part of the AVRIDE device driver
*
*  Copyright (C) 2002  Michael Fischer <mifi42@web.de>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************
*  History:
*
*  14.12.02  mifi   First Version 
****************************************************************************/
#ifndef __FAT32_H__
#define __FAT32_H__

#include "ide.h"
#include "typedefs.h"

/*-------------------------------------------------------------------------*/
/* global defines                                                          */
/*-------------------------------------------------------------------------*/
#define FAT32_MAX_FILES         10

#define FAT32_SUPPORT_FORMAT    0
#define FAT32_SUPPORT_FILEOPEN  1
#define FAT32_SUPPORT_FILECLOSE 1
#define FAT32_SUPPORT_FILEERROR 0
#define FAT32_SUPPORT_FILESIZE  1
#define FAT32_SUPPORT_FILESEEK  0
#define FAT32_SUPPORT_FILEREAD  1

#define FAT32_OK                0
#define FAT32_ERROR             -1
#define FAT32_ERROR_HANDLE      -2
#define FAT32_ERROR_EOF         -3
#define FAT32_ERROR_IDE         -4

/*-------------------------------------------------------------------------*/
/* global types                                                            */
/*-------------------------------------------------------------------------*/
typedef void FILE;

/*-------------------------------------------------------------------------*/
/* global macros                                                           */
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/* Prototypes                                                              */
/*-------------------------------------------------------------------------*/
int   FAT32Init (void);

#if (FAT32_SUPPORT_FORMAT == 1)

int   FAT32Format (BYTE bDevice);

#endif

FILE *FAT32FileOpen (char *pName);
int   FAT32FileClose (FILE *pFile);
int   FAT32FileError (FILE *pFile);
long  FAT32FileSize (FILE *pFile);
int   FAT32FileSeek (FILE *pFile, long lPos);

int   FAT32FileRead (FILE *pFile, void *pData, int nSize);

#endif /* !__FAT32_H__ */
