/****************************************************************************
*  This file is part of the AVRIDE device driver
*
*  Copyright (C) 2002  Michael Fischer <mifi42@web.de>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
****************************************************************************
*  History:
*
*  14.12.02  mifi   First Version 
****************************************************************************/
#ifndef __IDE_H__
#define __IDE_H__

#include "typedefs.h"

/*-------------------------------------------------------------------------*/
/* global defines                                                          */
/*-------------------------------------------------------------------------*/
#define IDE_OK                          0x00
#define IDE_ERROR                       0x01
#define IDE_DRIVE_NOT_FOUND             0x02
#define IDE_PARAM_ERROR                 0x03
#define IDE_BUSY                        0x04
                                        
#define IDE_DRIVE_C                     0
#define IDE_DRIVE_D                     1
                                        
#define IDE_SECTOR_SIZE                 512

#define IDE_MAX_SUPPORTED_DEVICE        1


#define IDE_SUPPORT_WRITE               1

/*-------------------------------------------------------------------------*/
/* global types                                                            */
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/* global macros                                                           */
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/* Prototypes                                                              */
/*-------------------------------------------------------------------------*/
int   IDEInit (BYTE *pSectorBuffer);

int   IDEMountDevice (BYTE bDevice, BYTE *pSectorBuffer);

DWORD IDEGetTotalSectors (BYTE bDevice);

int   IDEReadSectors (BYTE   bDevice,      void *pData, 
                      DWORD dwStartSector, WORD  wSectorCount);

#if (IDE_SUPPORT_WRITE == 1)

int   IDEWriteSectors (BYTE   bDevice,      void *pData, 
                       DWORD dwStartSector, WORD  wSectorCount);

#endif

#endif /* !__IDE_H__ */